<?php

namespace FiloBlu\Rma\Plugin\Model\Rma\Status;

use Magento\Sales\Api\OrderRepositoryInterface;

/**
 *
 */
class History
{
    /**
     * @var OrderRepositoryInterface
     */
    private $orderRepository;

    /**
     * History constructor.
     * @param OrderRepositoryInterface $orderRepository
     */
    public function __construct(OrderRepositoryInterface $orderRepository) {
        $this->orderRepository = $orderRepository;
    }

    /**
     * @param \Magento\Rma\Model\Rma\Status\History $subject
     * @param callable $proceed
     * @return \Magento\Rma\Model\Rma\Status\History
     */
    public function aroundSendNewRmaEmail(\Magento\Rma\Model\Rma\Status\History $subject, callable $proceed)
    {
        $order = $subject->getRma()->getOrder();
        if (!$order->getId()) {
            return $subject;
        }
        $itemToShip = false;
        $itemsOrdered = $order->getItems();
        foreach ($itemsOrdered as $item) {
            if ($item->getPrice() > 0) {
                if ($item->getQtyInvoiced() - $item->getQtyShipped() > 0) {
                    $itemToShip = true;
                    break;
                }
            }
        }
        if ($itemToShip) {
            return $subject;
        }
        return $proceed();
    }
}
